﻿Type=Activity
Version=3.2
@EndOfDesignText@
#Region Module Attributes
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Dim edtFirstName, edtLastName, edtAddress, edtCity, edtBirthday As EditText
	Dim btnUpdate, btnAddNew, btnDelete As Button
	Dim WebView1 As WebView
	Dim lstTable As List
	Dim pnlToolBox As Panel
	
	Dim col, row, ID As Int
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("edit")
	
	pnlToolBox.Top = 100%y - pnlToolBox.Height
	WebView1.Height = pnlToolBox.Top - (edtCity.Top + edtCity.Height + 4dip)
	
	FillWebView
	pnlToolBox.Visible = True
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub FillWebView
	Dim Query As String

	Query = "SELECT * FROM " & Main.DBTableName 
	' the line above does the same as the line below
	' in bothe cases the WebView column names are the same as the DB column names
	' Query = "SELECT ID, FirstName, LastName, Address, City FROM " & Main.DBTableName
	WebView1.LoadHtml(DBUtils.ExecuteHtml(Main.SQL1, Query, Null, 0, True))
	lstTable = DBUtils.ExecuteMemoryTable(Main.SQL1, Query, Null, 0)
End Sub

Sub WebView1_OverrideUrl (Url As String) As Boolean
	'parse the row and column numbers from the URL
	Dim values() As String
	values = Regex.Split("[.]", Url.SubString(8))
	col = values(0)
	row = values(1)
	
	Dim val(6) As String
	val = lstTable.Get(row)
	ID = val(0)
	edtFirstName.Text = val(1)
	edtLastName.Text = val(2)
	edtAddress.Text = val(3)
	edtCity.Text = val(4)
	edtBirthday.Text = val(5)
	pnlToolBox.Visible = True
	Return True 'Don't try to navigate to this URL
End Sub

Sub btnUpdate_Click
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to update this entry ?", "ATTENTION", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then
		Dim mp As Map
		mp.Initialize
		mp.Put("ID", ID)
		DBUtils.UpdateRecord(Main.SQL1, Main.DBTableName, "FirstName", edtFirstName.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, Main.DBTableName, "LastName", edtLastName.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, Main.DBTableName, "Address", edtAddress.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, Main.DBTableName, "City", edtCity.Text, mp)
		DBUtils.UpdateRecord(Main.SQL1, Main.DBTableName, "Birthday", edtBirthday.Text, mp)
		
		FillWebView
	End If
End Sub

Sub btnAddNew_Click
	' adds the new record
	If RecordExists = False Then
		Dim maps As List
		Dim mp As Map
		maps.Initialize
		mp.Initialize
		mp.Put("ID",Null)
		mp.Put( "FirstName", edtFirstName.Text)
		mp.Put( "LastName", edtLastName.Text)
		mp.Put( "Address", edtAddress.Text)
		mp.Put( "City", edtCity.Text)
		mp.Put( "Birthday", edtBirthday.Text)
		maps.Add(mp)
		DBUtils.InsertMaps(Main.SQL1, Main.DBTableName, maps)

		FillWebView
	End If
End Sub

Sub RecordExists As Boolean
	Dim Query As String
	Dim curs As Cursor

	' checks if the record already exists
	Query = "SELECT * FROM " & Main.DBTableName & _
		" WHERE FirstName='" & edtFirstName.Text & _
		"' AND LastName='" & edtLastName.Text & _
		"' AND Address='" & edtAddress.Text & _
		"' AND City='" & edtCity.Text & _
		"' AND Birthday='" & edtBirthday.Text & "'"
	curs = Main.SQL1.ExecQuery(Query)
	If curs.RowCount > 0 Then
		Msgbox("This record already exists", "A T T E N T I O N")
		Return True
	Else
		Return False
	End If
End Sub

Sub btnDelete_Click
	Dim Answ As Int
	
	Answ = Msgbox2("Do you really want to delete this record ?", "DELETE record", "Yes", "", "No", Null)

	If Answ = DialogResponse.POSITIVE Then
		Dim mp As Map
		Dim val(6) As String
		mp.Initialize
		mp.Put("ID", ID)
		val = lstTable.Get(row)
		mp.Put("FirstName", val(1))
		mp.Put("LastName", val(2))
		mp.Put("Address", val(3))
		mp.Put("City", val(4))
		mp.Put("Birthday", val(5))
		DBUtils.DeleteRecord(Main.SQL1, Main.DBTableName, mp)
		FillWebView
		edtFirstName.Text = ""
		edtLastName.Text = ""
		edtAddress.Text = ""
		edtCity.Text = ""
		edtBirthday.Text = ""
		row = -1
		col = -1
		pnlToolBox.Visible = False
	End If
End Sub
